<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <!-- Bootstrap core CSS -->
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous" />
    <link href="../css/cwrc.css" rel="stylesheet" type="text/css" />
    <link rel="shortcut icon" href="../css/favicon.ico" type="image/x-icon" />
    <link rel="icon" href="../css/favicon.ico" type="image/x-icon" />
    <title>Query Modifiers</title>
</head>

<body>
    <nav class="navbar navbar-expand-lg navbar-dark fixed-top bg-dark">
        <a class="navbar-brand" href="/">
            <img src="http://sparql.cwrc.ca/images/cwrclogo-vert-white.png" height="30" class="align-top" alt="CWRC Logo" /> CWRC Linked Data</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item"><a class="nav-link" href="/">Home</a></li>
                <li class="nav-item"><a class="nav-link" href="/sparql">SPARQL Queries</a></li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Preambles
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="../cwrc-preamble-EN.html">CWRC Ontology</a>
                        <a class="dropdown-item" href="../genre-preamble-EN.html">Genre Ontology</a>
                        <a class="dropdown-item" href="../ii-preamble-EN.html">II Ontology</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Specifications
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="../cwrc.html">CWRC Ontology</a>
                        <a class="dropdown-item" href="../genre.html">Genre Ontology</a>
                        <a class="dropdown-item" href="../ii.html">II Ontology</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Documentation
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="our-dataset.html">Our Dataset</a>
                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="sparql-query-guide.html">SPARQL Query Guide</a>
                        <a class="dropdown-item" href="intro-to-sparql.html">Intro to SPARQL</a>
                        <a class="dropdown-item" href="query-modifiers.html">Query Modifiers</a>
                        <a class="dropdown-item" href="sample-queries.html">Sample Queries</a>
                        <a class="dropdown-item" href="load-into-huviz.html">Load into HuViz</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="NavbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        About
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="cwrc.html">CWRC</a>
                        <a class="dropdown-item" href="linked-data.html">Linked Data</a>
                        <a class="dropdown-item" href="../our-team-EN.html">Our Team</a>
                        <a class="dropdown-item" href="https://github.com/cwrc/ontology">Github</a>
                    </div>
                </li>
            </ul>
            <span class="navbar-text">The Ontology of the Canadian Writing Research Collaboratory</span>
        </div>
    </nav>
    <div class="container-fluid">
        <div class="row">
            <nav class="col-xl-2 col-lg-3 col-md-12 d-none d-lg-block bg-light sidebar">
                <div class="sidebar-sticky">
                    <div class="sidebar-heading justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                        <span>Table of Contents</span>
                        <a class="d-flex align-items-center text-muted" href="#"></a>
                        <div id="toc">
                            <!-- Table of Contents -->
                        </div>
                    </div>
                </div>
            </nav>
            <main role="main" class="col-xl-10 col-lg-9 col-md-12 ml-sm-auto pt-3 px-4" data-spy="scroll" data-target="#toc">
                <h1>Query modifiers: refining your search</h1>
                <p>SPARQL has many built-in keywords which can be used to refine your search. The table below provides a list of some of the main keywords
                    along with a brief description.</p>
                <table class="table table-hover normal">
                    <thead>
                        <tr>
                            <th>Keyword</th>
                            <th>Purpose</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>FILTER</td>
                            <td>An expression that modifies your search is placed in the filter paraenthesis. See <a href="#Query1">Query 1</a> for an example.</td>
                        </tr>
                        <tr>
                            <td>FILTER NOT EXISTS</td>
                            <td>Returns true if a specified graph pattern does not exist.</td>
                        </tr>
                        <tr>
                            <td>OPTIONAL</td>
                            <td>Makes certain patterns of preceding triples optional. See <a href="#Query2">Query 2</a> for an example.</td>
                        </tr>
                        <tr>
                            <td>MINUS</td>
                            <td>Similar to FILTER NOT EXISTS; subtracts the graph pattern in the argument.</td>
                        </tr>
                        <tr>
                            <td>UNION</td>
                            <td>Allows for the retrieval of different graph patters at once. </td>
                        </tr>
                        <tr>
                            <td>OFFSET</td>
                            <td>Skips the first number of rows specified by offset.</td>
                        </tr>
                        <tr>
                            <td>LIMIT</td>
                            <td>Limits the number of outputs displayed in a random order.</td>
                        </tr>
                        <tr>
                            <td>VALUES</td>
                            <td>Specifies values for variables; allows for more than one match.</td>
                        </tr>
                        <tr>
                            <td>ORDER BY</td>
                            <td>Sorts the data using the values in the argument. Data are shown in ascending order unless otherwise specified. See <a href="#Query3">Query 3</a> for an example.</td>
                        </tr>
                        <tr>
                            <td>GROUP BY</td>
                            <td>Groups data together to perform aggregate functions. See <a href="#Query4">Query 4</a> for an example.</td>
                        </tr>
                        <tr>
                            <td>GRAPH</td>
                            <td>Specifies which graph data will be retrieved from.</td>
                        </tr>
                    </tbody>
                </table>
                <h2>Examples:</h2>
                <!-- Query 1 -->
                <h3 id="Query1"><a target="_blank" href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0APREFIX+rdfs%3A+%3Chttp%3A%2F%2Fwww.w3.org%2F2000%2F01%2Frdf-schema%23%3E%0A%0ASELECT+%3Fname+%0AWHERE+%7B+%0A++++%3Fperson+cwrc%3AhasGender+cwrc%3Awoman+.%0A++++%3Fperson+rdfs%3Alabel+%3Fname+.%0AFILTER(regex(%3Fname%2C+%22Anne%22%2C+%22i%22))+%0A%7D+++&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Query+1&headers=%7B%7D&outputFormat=table">Women named Anne</a></h3>
                <pre>
                    <code>PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;
PREFIX rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt;

SELECT ?name 
WHERE { 
    ?person cwrc:hasGender cwrc:woman .
    ?person rdfs:label ?name .
FILTER(regex(?name, "Anne", "i")) 
}                   </code>
                </pre>
                <p>The FILTER command takes a single argument. Many of the arguments make use of a function.
                    Here, the function regex is used to filter the results based on the label of the person. The query
                    returns all the names of the women in the dataset, and the filter command reduces that output
                    to only those containing the name "Anne". The "i" is for "insensitive"; this means the results can
                    be either uppercase or lowercase.</p>
                <!-- Query 2 -->
                <h3 id="Query2"><a href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0APREFIX+skos%3A+%3Chttp%3A%2F%2Fwww.w3.org%2F2004%2F02%2Fskos%2Fcore%23%3E%0A%0ASELECT+%3Fname+%3Foccupation+%0AWHERE+%7B+%0A++++%3Fperson+cwrc%3AhasGender+cwrc%3Awoman+%3B%0A++++%09%09cwrc%3AhasOccupation+%3Foccupation+%3B+%0A++++++%09%09skos%3AaltLabel+%3Fname%0A++++%0A++++OPTIONAL+%7B%3Foccupation+a+cwrc%3Ateacher%7D%0A%7D+&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Women's+occupations+(Optional)&headers=%7B%7D&outputFormat=table" target="_blank">Women's occupations</a></h3>
                <pre>
                    <!-- THIS is a bad query: poor explanation of optional clause, use of the word tag is questionable -->
                    <code>PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;
PREFIX skos: &lt;http://www.w3.org/2004/02/skos/core#&gt;                        
SELECT ?name ?occupation 
WHERE { 
    ?person cwrc:hasGender cwrc:woman ;
            cwrc:hasOccupation ?occupation ; 
            skos:altLabel ?name
    
    OPTIONAL {?occupation a cwrc:teacher}
}                    </code>
                </pre>
                <p>The OPTIONAL graph pattern does not need to be satisfied. If the OPTIONAL tag
                    was removed in this example, the resulting table would include all of the women who are teachers. The inclusion of the OPTIONAL tag
                    will display all women and their occupations, including women who are teachers. This is similar
                    to an outer join in SQL.</p>
                <h3 id="Query3"><a href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0APREFIX+skos%3A+%3Chttp%3A%2F%2Fwww.w3.org%2F2004%2F02%2Fskos%2Fcore%23%3E%0ASELECT+%3Fname+%3FbirthDate+%0AWHERE+%7B+%0A++++%3Fperson+cwrc%3AhasBirthDate+%3FbirthDate+%3B%0A++++++++++++skos%3AaltLabel+%3Fname%0A++++FILTER+((%3FbirthDate+%3E%3D+'1844-01-01'%5E%5Exsd%3Adate)+%26%26+(%3FbirthDate+%3C%3D+'1884-01-01'+%5E%5Exsd%3Adate))+.+%0A++%09%0A%7DORDER+BY+%3FbirthDate&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Birthdates+(Filter+%26+Order+by)&headers=%7B%7D&outputFormat=table" target="_blank">Birthdates</a></h3>
                <pre>
                    <code>PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;
PREFIX skos: &lt;http://www.w3.org/2004/02/skos/core#&gt;
SELECT ?name ?birthDate 
WHERE { 
    ?person cwrc:hasBirthDate ?birthDate ;
            skos:altLabel ?name
FILTER ((?birthDate &gt;= &apos;1844-01-01&apos;^^xsd:date) &amp;&amp; (?birthDate &lt;= &apos;1884-01-01&apos; ^^xsd:date)) . 
  &#x9;
}ORDER BY ?birthDate
                 </code>
                </pre>
                <p>This query searches for every person who has a birthdate between two specific dates. The triples that
                    satisfy this are then displayed in a table which will be ordered by birth dates from earliest to latest in
                    ascending numerical value.</p>
                <p>Literals:
                    The object of a triple can be a URI, a string, or a literal.
                    The data type can be specified if known. In the example above the data, in this case a date, is specified.</p>
                <p> Examples of other types:</p>
                <ul>
                    <li>d:item dm:quantity "4"<strong>^^xsd:integer</strong></li>
                    <li>d:item dm:invoiced "false"<strong>^^xsd:boolean</strong></li>
                    <li>d:item dm:costPerItem "3.50"<strong>^^xsd:decimal</strong></li>
                </ul>
                <h3 id="Query4"><a href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0A%0ASELECT+%3Foccupation+(COUNT(%3Fperson)+AS+%3FnumberPerProfession)+%0AWHERE+%7B+%0A++++%3Fperson+a+cwrc%3ANaturalPerson%3B%0A++++%09cwrc%3AhasOccupation+%3Foccupation.%0A%7D%0AGROUP+BY+%3Foccupation+%0AORDER+BY+DESC+(%3FnumberPerProfession)&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Counting+professions+(Group+by+%26+Order+by+desc)&headers=%7B%7D&outputFormat=table" target="_blank">Counting professions</a></h3>
                <pre>
                    <code>PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;

SELECT ?occupation (COUNT(?person) AS ?numberPerProfession) 
WHERE { 
    ?person a cwrc:NaturalPerson;
        cwrc:hasOccupation ?occupation.
}
GROUP BY ?occupation 
ORDER BY DESC (?numberPerProfession)</code>
                </pre>
                <p>The GROUP BY function groups functions together. These functions can then be performed on each group. The query above groups results by occupation. The COUNT function then adds the number of people with that profession. The table will have two columns: one for occupation, the other, called numberPerProfession, with an amount.
                </p>
                <p>Other functions:</p>
                <ul>
                    <li>AVG()</li>
                    <li>MAX()</li>
                    <li>MIN()</li>
                    <li>SUM()</li>
                    <li>COUNT()</li>
                </ul>
            </main>
        </div>
    </div>
    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.bundle.min.js" integrity="sha384-feJI7QwhOS+hwpX2zkaeJQjeiwlhOP+SdQDqhgvvo1DsjtiSQByFdThsxO669S2D" crossorigin="anonymous"></script>
    <script src="../js/toc.js"></script>
    <script>
    var options = {
        selector: 'h2, h3, h4',
        scope: 'main'
    };

    var container = document.querySelector('#toc');
    var toc = initTOC(options);
    container.appendChild(toc);
    </script>
</body>

</html>